## sagemath 9.2

=== sage/Makefile ===
# Main Makefile for Sage.

# The default target ("all") builds Sage and the whole (HTML) documentation.
#
# Target "build" just builds Sage.
#
# See below for targets to build the documentation in other formats,
# to run various types of test suites, and to remove parts of the build etc.

default: all

all: base-toolchain
	$(MAKE) all-start

build: base-toolchain
	$(MAKE) all-build

start: base-toolchain
	$(MAKE) build-start

sageruntime: base-toolchain
	$(MAKE) all-sageruntime


# The --stop flag below is just a random flag to induce graceful
# breakage with non-GNU versions of make.
# See https://trac.sagemath.org/ticket/24617

# Defer unknown targets to build/make/Makefile
%::
	@if [ -x relocate-once.py ]; then ./relocate-once.py; fi
	$(MAKE) build/make/Makefile --stop
	+build/bin/sage-logger \
		"cd build/make && ./install '$@'" logs/install.log

# CONFIG_FILES lists all files that appear in AC_CONFIG_FILES in configure.ac;
# except for build/make/Makefile-auto, which is unused by the build system
CONFIG_FILES = build/make/Makefile src/bin/sage-env-config build/bin/sage-build-env-config build/pkgs/sage_conf/src/sage_conf.py build/pkgs/sage_conf/src/setup.cfg

# SPKG_COLLECT_FILES contains all files that influence the SAGE_SPKG_COLLECT macro
SPKG_COLLECT_FILES = build/pkgs/*/type build/pkgs/*/package-version.txt build/pkgs/*/dependencies build/pkgs/*/requirements.txt build/pkgs/*/checksums.ini build/pkgs/*/spkg-install

# If configure was run before, rerun it with the old arguments.
# Otherwise, run configure with argument $PREREQ_OPTIONS.
build/make/Makefile: configure $(SPKG_COLLECT_FILES) $(CONFIG_FILES:%=%.in)
	rm -f config.log
	mkdir -p logs/pkgs
	ln -s logs/pkgs/config.log config.log
	@if [ -x config.status ]; then \
		./config.status --recheck && ./config.status; \
	else \
		echo >&2 '****************************************************************************'; \
		echo >&2 'error: Sage source tree is unconfigured. Please run "./configure" first.'; \
		echo >&2 'note:  Type "./configure --help" to see the available configuration options.'; \
		echo >&2 '****************************************************************************'; \
	        exit 1; \
	fi

# This is used to monitor progress towards Python 3 and prevent
# regressions. Should be removed after the full switch to python3.
#
# As of Sage 9.0: keep the build target for backward compatibility,
# but it just runs "make".
buildbot-python3:
	$(MAKE)

# Preemptively download all standard upstream source tarballs.
download:
	export SAGE_ROOT=$$(pwd) && \
	export PATH=$$SAGE_ROOT/src/bin:$$PATH && \
	./src/bin/sage-download-upstream

dist: build/make/Makefile
	./sage --sdist

# ssl: build Sage, and also install pyOpenSSL. This is necessary for
# running the secure notebook. This make target requires internet
# access. Note that this requires that your system have OpenSSL
# libraries and headers installed. See README.txt for more
# information.
ssl: all
	./sage -i pyopenssl

# Deleting src/lib is to get rid of src/lib/pkgconfig
# that was forgotten to clean in #29082.
misc-clean:
	@echo "Deleting build artifacts generated by autoconf, automake, make ..."
	rm -rf logs
	rm -rf dist
	rm -rf tmp
	rm -f aclocal.m4 config.log confcache
	rm -rf autom4te.cache
	rm -f build/make/Makefile build/make/Makefile-auto
	rm -rf src/lib

bdist-clean: clean
	$(MAKE) misc-clean
	@echo "Deleting build artifacts generated by configure ..."
	rm -f config.status

distclean: build-clean
	$(MAKE) misc-clean
	@echo "Deleting all remaining output from build system ..."
	rm -rf local
	rm -f src/bin/sage-env-config

# Delete all auto-generated files which are distributed as part of the
# source tarball
bootstrap-clean:
	rm -rf config configure build/make/Makefile-auto.in
	rm -f src/doc/en/installation/*.txt
	rm -rf src/doc/en/reference/spkg/*.rst
	rm -f src/doc/en/reference/repl/*.txt

# Remove absolutely everything which isn't part of the git repo
maintainer-clean: distclean bootstrap-clean
	rm -rf upstream

# Remove everything that is not necessary to run Sage and pass all its
# doctests.
micro_release:
	$(MAKE) sagelib-clean
	$(MAKE) misc-clean
	@echo "Stripping binaries ..."
	LC_ALL=C find local/lib local/bin -type f -exec strip '{}' ';' 2>&1 | grep -v "File format not recognized" |  grep -v "File truncated" || true
	@echo "Removing sphinx artifacts..."
	rm -rf local/share/doc/sage/doctrees local/share/doc/sage/inventory
	@echo "Removing documentation. Inspection in IPython still works."
	rm -rf local/share/doc local/share/*/doc local/share/*/examples local/share/singular/html
	@echo "Removing unnecessary files & directories - make will not be functional afterwards anymore"
	@# We need src/doc/common, src/doc/en/introspect for introspection with "??"
	@# We keep src/sage for some doctests that it expect it to be there and
	@# also because it does not add any weight with rdfind below.
	@# We need src/sage/bin/ for the scripts that invoke Sage
	@# We need sage, the script to start Sage
	@# We need local/, the dependencies and the built Sage library itself.
	@# We keep VERSION.txt.
	@# We keep COPYING.txt so we ship a license with this distribution.
	find . -name . -o -prune ! -name config.status ! -name src ! -name sage ! -name local ! -name VERSION.txt ! -name COPYING.txt ! -name build -exec rm -rf \{\} \;
	cd src && find . -name . -o -prune ! -name sage ! -name bin ! -name doc -exec rm -rf \{\} \;
	if command -v rdfind > /dev/null; then \
		echo "Hardlinking identical files."; \
		rdfind -makeresultsfile false -makehardlinks true .; \
	else \
		echo "rdfind not installed. Not hardlinking identical files."; \
	fi

# Leaves everything that is needed to make the next "make" fast but removes
# all the cheap build artifacts that can be quickly regenerated.
fast-rebuild-clean: misc-clean
	rm -rf upstream/
	rm -rf src/build/temp.*
	# Without site-packages/sage sage does not start but copying/compiling
	# them from src/build is very fast.
	rm -rf local/lib/python*/site-packages/sage
	# The .py files in src/build are restored from src/sage without their
	# mtimes changed.
	find src/build -name '*.py' -exec rm \{\} \;

TESTALL = ./sage -t --all
PTESTALL = ./sage -t -p --all

# Flags for ./sage -t --all.
# By default, include all tests marked 'dochtml' -- see
# https://trac.sagemath.org/ticket/25345 and
# https://trac.sagemath.org/ticket/26110.
TESTALL_FLAGS = --optional=sage,dochtml,optional,external,build

test: all
	$(TESTALL) --logfile=logs/test.log

check: test

testall: all
	$(TESTALL) $(TESTALL_FLAGS) --logfile=logs/testall.log

testlong: all
	$(TESTALL) --long --logfile=logs/testlong.log

testalllong: all
	$(TESTALL) --long $(TESTALL_FLAGS) --logfile=logs/testalllong.log

ptest: all
	$(PTESTALL) --logfile=logs/ptest.log

ptestall: all
	$(PTESTALL) $(TESTALL_FLAGS) --logfile=logs/ptestall.log

ptestlong: all
	$(PTESTALL) --long --logfile=logs/ptestlong.log

ptestalllong: all
	$(PTESTALL) --long $(TESTALL_FLAGS) --logfile=logs/ptestalllong.log

testoptional: all
	$(TESTALL) --logfile=logs/testoptional.log

testoptionallong: all
	$(TESTALL) --long --logfile=logs/testoptionallong.log

ptestoptional: all
	$(PTESTALL) --logfile=logs/ptestoptional.log

ptestoptionallong: all
	$(PTESTALL) --long --logfile=logs/ptestoptionallong.log

configure: bootstrap src/doc/bootstrap configure.ac src/bin/sage-version.sh m4/*.m4 build/pkgs/*/spkg-configure.m4 build/pkgs/*/type build/pkgs/*.txt build/pkgs/*/distros/*.txt
	./bootstrap -d

install: all
	@echo "******************************************************************"
	@echo "The '$@' target is a no-op; 'make' already does 'make install'"
	@echo "You can change the install prefix from its default"
	@echo "(the subdirectory 'local') by using ./configure --prefix=PREFIX"
	@echo "You can also consider using the binary packaging scripts"
	@echo "from https://github.com/sagemath/binary-pkg"
	@echo "******************************************************************"

list:
	@$(MAKE) --silent build/make/Makefile >&2
	@$(MAKE) --silent -f build/make/Makefile SAGE_SPKG_INST=local $@

.PHONY: default build dist install micro_release \
	misc-clean bdist-clean distclean bootstrap-clean maintainer-clean \
	test check testoptional testall testlong testoptionallong testallong \
	ptest ptestoptional ptestall ptestlong ptestoptionallong ptestallong \
	buildbot-python3 list

=== sage/src/doc/Makefile ===
all:
	@echo "Please build the doc using either 'make doc' from SAGE_ROOT, or"
	@echo "'sage -docbuild all html'. See 'sage -docbuild help' for more informations."
clean:
	rm -rf en/reference/*/sage
	rm -rf en/reference/sage
	rm -f common/*.pyc

=== sage/src/mac-app/Makefile ===
# Makefile for building the Mac App
#
# This assumes that you have already built Sage. This Makefile then
# compiles the Mac App UI and combines it with the existing Sage
# install into a DMG file.
#
# The resulting DMG is as relocatable as the original Sage install,
# that is, not at all by default. It will contain paths pointing to
# the Sage tree that you started with (OK if you are only debugging
# the Mac App, just don't delete the original Sage directory tree).
#
# To build a relocatable Sage binary you have to use
# https://github.com/sagemath/binary-pkg


ifdef SAGE_ROOT
    $(error This makefile must be run outside of a sage shell)
endif

SAGE_ROOT:=$(shell cd ../.. && pwd)

ifndef SAGE_VERSION
    SAGE_VERSION:=$(shell source ../bin/sage-version.sh && echo $$SAGE_VERSION)
endif

# Meaningful values, on Intel, are "i386" and "x86_64". To prepare a
# 64-bit binary distribution on an older 64-bit OSX machine that boots
# into a 32-bit system, one would set SAGE_APP_TARGET_ARCH=x86_64
ifndef SAGE_APP_TARGET_ARCH
    SAGE_APP_TARGET_ARCH:=$(shell uname -m)
endif

OSX_VERSION:=$(shell sw_vers -productVersion)

TARGET:=sage-$(SAGE_VERSION)-OSX_$(OSX_VERSION)_$(SAGE_APP_TARGET_ARCH)
APP_NAME:=SageMath-$(SAGE_VERSION).app
APP:=$(TARGET)/$(APP_NAME)
DMG:=$(TARGET).app.dmg

CONFIGURATION=Debug
SDKROOT=

SOURCE=*.h *.m

default: $(DMG)
app: $(APP)/Contents/Resources/sage

# Display the variables
debug:
	@echo SAGE_ROOT=$(SAGE_ROOT)
	@echo SAGE_VERSION=$(SAGE_VERSION)
	@echo OSX_VERSION=$(OSX_VERSION)
	@echo SAGE_APP_TARGET_ARCH=$(SAGE_APP_TARGET_ARCH)
	@echo CONFIGURATION=$(CONFIGURATION)
	@echo APP=$(APP)

# Build the Mac App UI binary (not: Sage itself)
$(APP): $(SOURCE)
	mkdir -p $(TARGET)
	xcodebuild -target Sage -configuration $(CONFIGURATION) \
	    ARCHS=$(SAGE_APP_TARGET_ARCH) \
	    ONLY_ACTIVE_ARCH=NO \
	    SDKROOT=$(SDKROOT)
	mkdir -p $(APP)
	cp -pRL build/$(CONFIGURATION)/Sage.app/ $(APP)
	@# Info.plist is a binary plist, so convert it for processing with sed.
	@# I would just change it to be an xml plist, but xcode changes it back.
	plutil -convert xml1 $(APP)/Contents/Info.plist
	sed -i '' "s/SAGE_VERSION/$(SAGE_VERSION)/" $(APP)/Contents/Info.plist

# Copy Sage into the App directory structure
$(APP)/Contents/Resources/sage: $(APP)
	mkdir -p $(APP)/Contents/Resources/sage
	rsync -av --progress \
	    $(SAGE_ROOT)/ $@ \
	    --exclude .git/ \
	    --exclude upstream/ \
	    --exclude src/mac-app/build \
	    --exclude src/mac-app/$(TARGET) \
	    --exclude src/mac-app/$(DMG) \
	    --exclude src/mac-app/tmp-$(DMG)
	@# We touch the director here so that we don't keep rsyncing just
	@# because $(APP) is newer than (the rsync preserves time)
	test -d $@ && touch $@

# The background image for the DMG.
# It contains the arrow pointing from the .app to the Applications
# folder.
#
# The background image should be at 72dpi. if a different resolution is
# set in the metadata, Finder produces weird results.
#
$(TARGET)/.background.png: sage-dmg-background.png
	cp sage-dmg-background.png $(TARGET)/.background.png

# Link to Applications
$(TARGET)/Applications:
	rm -f $(TARGET)/Applications
	ln -s /Applications/ $(TARGET)/Applications

# Add the readme file
$(TARGET)/README.txt: sage-README-macOS.txt
	cp $^ $@

non_app_files: $(TARGET)/README.txt $(TARGET)/Applications

sage_symlink: $(APP)/Contents/Resources/sage
	rm -f $(APP)/sage
	ln -s Contents/Resources/sage/sage $(APP)/sage

# The arrangement of the icons and the "alias" or "bookmark" for the
# background image are stored in a .DS_Store file.
# The .DS_Store file does not store the background image by relative path,
# but by "alias" or "bookmark" which contains the volume name as well - so
# we cannot just generate the .DS_Store once and for all and copy it from
# version to version since the volume name contains the version.
$(TARGET)/.DS_Store: tools/createDSStore/createDSStore.py
	@# On some old Mac OS X, createDSStore fails when there already
	@# is an existing file
	rm -f $(TARGET)/.DS_Store
	tools/createDSStore/createDSStore.py $(TARGET) $(TARGET) $(APP_NAME)

# Dependencies need to be in that order because non_app_files
# needs the directory created by $(APP)/Contents/Resources/sage
$(DMG): $(APP)/Contents/Resources/sage sage_symlink $(TARGET)/.background.png $(TARGET)/.DS_Store non_app_files 
	hdiutil create -srcfolder $(TARGET) -volname $(TARGET) -format UDBZ $(DMG)

###############################################################################
# Alternative method to create the .dmg
# 
# The .DS_Store file created above with createDSStore doesn't display correctly
# on some versions of Mac OS X (it appears the first releases of Mac OS 10.12),
# see tickets 22739 and 23426.
# The reason is that Finder introduced a new way ("bookmark") of storing the
# location of the background image in the .DS_Store file and bugs in reading the
# old format ("alias"), see https://bitbucket.org/al45tair/ds_store/issues/7 
# which also describes how createDSStore could be updated to write a "bookmark"
# as well.
# 
# An alternative method is to use AppleScript. Unfortunately, this requires
# generating a temporary read-write disk image, mounting it, then calling the
# AppleScript to set the background image and finally compressing the disk
# image.
#
# To experiment with the alternative method, call alt-$(DMG).

$(TARGET)/.background/sage.png: sage-dmg-background.png
	mkdir -p $(TARGET)/.background
	cp sage-dmg-background.png $(TARGET)/.background/sage.png

# The temporary read-write disk image.
#
# Dependencies need to be in that order because non_app_files
# needs the directory created by $(APP)/Contents/Resources/sage
tmp-$(DMG): $(APP)/Contents/Resources/sage sage_symlink $(TARGET)/.background/sage.png non_app_files
	@# Create initial DMG
	hdiutil create -srcfolder $(TARGET) -volname $(TARGET) -format UDRW tmp-$(DMG)

	@# Mount it so that we can run the Apple Script file on it
	@# to arrange the icons and set the background image
	mkdir -p mnt
	hdiutil attach tmp-$(DMG) -mountpoint mnt
	osascript tools/arrangeIcons.applescript mnt $(APP_NAME)
	hdiutil detach mnt

# Compress the temporary DMG
alt-$(DMG): tmp-$(DMG)
	hdiutil convert -format UDBZ -o alt-$(DMG) tmp-$(DMG)	

#
#
# End of alternative method
###############################################################################

.PHONY: clean default debug app non_app_files sage_symlink

clean:
	rm -rf $(TARGET) build $(DMG) tmp-$(DMG) mnt

=== sage/build/pkgs/nibabel/requirements.txt ===
nibabel

=== sage/build/pkgs/pyopenssl/requirements.txt ===
service_identity
pyopenssl

=== sage/build/pkgs/pyx/requirements.txt ===
pyx

=== sage/build/pkgs/sage_sws2rst/src/requirements.txt ===
six
beautifulsoup4

=== sage/build/pkgs/sagelib/src/requirements.txt ===
#sage_conf
#sage_setup
six             # use of six should be removed from sage_setup
Cython==0.29.17
pkgconfig
cysignals
gmpy2==2.1.0b5

numpy          # already needed by sage.env
jinja2         # sage_setup.autogen.interpreters

cypari2        # but building bdist_wheel of cypari2 fails with recent pip... https://github.com/sagemath/cypari2/issues/93

########## Runtime

psutil
pexpect
pplpy
ipython<=5.8

=== debian/changelog ===
sagemath (9.2-2) unstable; urgency=medium

  * Do not hardcode python minor version in d/rules. (Closes: #972916)
  * New patches:
    - u0-version-pari-2.13.patch (Closes: #974991)
    - u0-version-pari-2.13-spkg-configure.patch
    - dt-avoid-pari-timeout.patch

 -- Tobias Hansen <thansen@debian.org>  Sun, 22 Nov 2020 00:40:14 +0000

sagemath (9.2-1) unstable; urgency=medium

  * New upstream release. (Closes: #972916)
  * Remove patches (applied upstream):
    - d0-maxima.patch #30563
  * Update debian/watch.

 -- Tobias Hansen <thansen@debian.org>  Mon, 26 Oct 2020 19:59:07 +0000

=== debian/control ===
## DO NOT EDIT debian/control directly, edit debian/control.in instead
Source: sagemath
Section: math
Priority: optional
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Tobias Hansen <thansen@debian.org>,
           Julien Puydt <julien.puydt@laposte.net>,
           Jerome Benoit <calculus@rezozer.net>,
           Ximin Luo <infinity0@debian.org>
Standards-Version: 4.5.1
Homepage: http://www.sagemath.org/
Vcs-Git: https://salsa.debian.org/science-team/sagemath.git
Vcs-Browser: https://salsa.debian.org/science-team/sagemath
Rules-Requires-Root: no
Build-Depends:
 curl,
 cysignals-tools (>= 1.8.1) <!nodoc>,
 cython3 (>= 0.29.1),
 ecl (>= 20.4.24),
 eclib-tools (>= 20180815),
 fflas-ffpack (>= 2.4.3),
 flintqs,
 gap-dev (>= 4.11.0),
 gap-online-help,
 gap-atlasrep (>= 2.1.0-2),
 gap-primgrp,
 gap-smallgrp,
 gap-transgrp,
 gap-table-of-marks,
 gfan (>= 0.6.2),
 glpk-utils,
 gmp-ecm,
 ipython3 (>= 7.11.1),
 iso-codes,
 jmol (>= 14.6.4),
 lcalc (>= 1.23+dfsg-10),
 less,
 libcdd-tools (>= 094j),
 libjs-mathjax,
 libjs-three (>= 111),
 maxima-sage (>= 5.44.0),
 maxima-sage-share (>= 5.44.0),
 nauty,
 palp (>= 2.1-2),
 pari-gp (>= 2.11.4~pre1),
 pari-gp2c,
 pari-elldata,
 pari-galdata,
 pari-galpol,
 pari-seadata,
 python3,
 python3-alabaster,
 python3-babel,
 python3-cvxopt,
 python3-cycler,
 python3-cypari2 (>= 2.1),
 python3-cysignals-pari (>= 1.8.1),
 python3-decorator,
 python3-docutils,
 python3-fpylll (>= 0.4.1),
 python3-future,
 python3-gmpy2,
 python3-imagesize,
 python3-ipython-genutils,
 python3-itsdangerous,
 python3-matplotlib (>= 2.1),
 python3-mistune,
 python3-mpmath,
 python3-networkx (>= 2.2),
 python3-nose,
 python3-numpy (>= 1:1.14),
 python3-packaging,
 python3-path,
 python3-pexpect (>= 4.1),
 python3-pickleshare,
 python3-pil,
 python3-pip,
 python3-pkgconfig,
 python3-ppl,
 python-ppl-doc (>= 0.8.4-4),
 python3-psutil,
 python3-ptyprocess,
 python3-pygments,
 python3-rpy2,
 python3-scipy (>= 1.2),
 python3-setuptools,
 python3-setuptools-scm,
 python3-simplegeneric,
 python3-singledispatch,
 python3-snowballstemmer,
 python3-sphinx (>= 3.0),
 python3-stemmer,
 python3-sympy,
 python3-terminado,
 python3-tk,
 python3-tornado,
 python3-traitlets,
 python3-tz,
 python3-vcversioner,
 python3-wcwidth,
 python3-werkzeug,
 python3-zmq,
 python3-zope.interface,
 r-base-core,
 rubiks,
 sagemath-database-conway-polynomials (>= 0.5-7),
 sagemath-database-elliptic-curves,
 sagemath-database-graphs,
 sagemath-database-mutually-combinatorial-designs,
 sagemath-database-polytopes,
 singular (>= 1:4.1.1-p2),
 singular (<< 1:4.1.1-p3+ds-1),
 sqlite3,
 sympow (>= 1.023-9),
 tachyon,
 xcas,
 yasm,
 maxima-sage-doc (>= 5.42.2),
 pari-doc (>= 2.11.0),
 python3-sagenb-export (>= 3.2),
 r-cran-lattice,
 singular-doc (>= 1:4.1.1-p2),
 singular-doc (<< 1:4.1.1-p3+ds-1),
 jupyter-client,
 jupyter-core,
 jupyter-nbextension-jupyter-js-widgets,
 python3-ipykernel,
 python3-ipywidgets (>= 6.0.0),
 python3-nbconvert,
 python3-nbformat,
 python3-notebook (>= 4.2.3-3),
 autoconf,
 cython3-dbg <pkg.sagemath.dbg>,
 debhelper (>= 10),
 dh-python (>= 2.20170125),
 dpkg-dev (>= 1.17.14),
 gdb,
 git,
 libc6-dbg <pkg.sagemath.dbg>,
 libboost-dev (>= 1.55),
 libbraiding-dev,
 libbrial-dev (>= 1.2.5-2),
 libbrial-groebner-dev (>= 1.2.5-2),
 libcdd-dev (>= 094j),
 libcliquer-dev,
 libcurl4-openssl-dev,
 libec-dev (>= 20190909-3),
 libecm-dev,
 libflint-arb-dev (>= 1:2.15),
 libflint-dev (>= 2.5.2-5),
 libfplll-dev (>= 5.2.1),
 libfreetype6-dev,
 libgap-dev,
 libgc-dev,
 libgd-dev,
 libgf2x-dev (>= 1.2-4),
 libgiac-dev (>= 1.4.9.69),
 libgivaro-dev (>= 4.1.1-2),
 libglpk-dev,
 libgmp-dev (>= 2:5.1.2),
 libgpg-error-dev,
 libgsl-dev (>= 2.4+dfsg-5~),
 libhomfly-dev,
 libiml-dev,
 liblfunction-dev (>= 1.23+dfsg-10),
 liblinbox-dev (>= 1.6.3),
 liblrcalc-dev (>= 1.2-2),
 libm4ri-dev (>= 20130416),
 libm4rie-dev (>= 20130416),
 libmpc-dev (>=1.0),
 libmpfi-dev,
 libmpfr-dev,
 libntl-dev (>= 9.9.1-2),
 libopenblas-dev,
 libpari-dev (>= 2.11.4~pre1),
 libplanarity-dev,
 libpng-dev,
 libppl-dev (>= 1:1.1),
 libpynac-dev (>= 0.7.26-5),
 libratpoints-dev,
 libreadline-dev,
 librw-dev,
 libsingular4-dev (>= 1:4.1.1-p2),
 libsingular4-dev (<< 1:4.1.1-p3+ds-1),
 libsqlite3-dev,
 libsymmetrica-dev,
 libzmq3-dev,
 libzn-poly-dev,
 pkg-config,
 ppl-dev,
 python3-debian,
 python3-dev,
 python3-dbg <pkg.sagemath.dbg>,
 python3-cysignals-pari-dbgsym <pkg.sagemath.dbg>,
 r-base-dev,
 rdfind,
 texlive-latex-base,
 zlib1g-dev,

Package: sagemath
Architecture: any
Multi-Arch: same
Description: Open Source Mathematical Software
 SageMath is a free open-source mathematics software system licensed under the
 GPL. It builds on top of many existing open-source packages: NumPy, SciPy,
 matplotlib, Sympy, Maxima, GAP, FLINT, R and many more. Access their combined
 power through a common, Python-based language or directly via interfaces or
 wrappers.
 .
 Mission: Creating a viable free open source alternative to Magma, Maple,
 Mathematica and Matlab.
 .
 This package contains the main SageMath installation.
Depends: ${misc:Depends}, ${shlibs:Depends}, ${python3:Depends},
 curl,
 cysignals-tools (>= 1.8.1) <!nodoc>,
 cython3 (>= 0.29.1),
 ecl (>= 20.4.24),
 eclib-tools (>= 20180815),
 fflas-ffpack (>= 2.4.3),
 flintqs,
 gap-dev (>= 4.11.0),
 gap-online-help,
 gap-atlasrep (>= 2.1.0-2),
 gap-primgrp,
 gap-smallgrp,
 gap-transgrp,
 gap-table-of-marks,
 gfan (>= 0.6.2),
 glpk-utils,
 gmp-ecm,
 ipython3 (>= 7.11.1),
 iso-codes,
 jmol (>= 14.6.4),
 lcalc (>= 1.23+dfsg-10),
 less,
 libcdd-tools (>= 094j),
 libjs-mathjax,
 libjs-three (>= 111),
 maxima-sage (>= 5.44.0),
 maxima-sage-share (>= 5.44.0),
 nauty,
 palp (>= 2.1-2),
 pari-gp (>= 2.11.4~pre1),
 pari-gp2c,
 pari-elldata,
 pari-galdata,
 pari-galpol,
 pari-seadata,
 python3,
 python3-alabaster,
 python3-babel,
 python3-cvxopt,
 python3-cycler,
 python3-cypari2 (>= 2.1),
 python3-cysignals-pari (>= 1.8.1),
 python3-decorator,
 python3-docutils,
 python3-fpylll (>= 0.4.1),
 python3-future,
 python3-gmpy2,
 python3-imagesize,
 python3-ipython-genutils,
 python3-itsdangerous,
 python3-matplotlib (>= 2.1),
 python3-mistune,
 python3-mpmath,
 python3-networkx (>= 2.2),
 python3-nose,
 python3-numpy (>= 1:1.14),
 python3-packaging,
 python3-path,
 python3-pexpect (>= 4.1),
 python3-pickleshare,
 python3-pil,
 python3-pip,
 python3-pkgconfig,
 python3-ppl,
 python-ppl-doc (>= 0.8.4-4),
 python3-psutil,
 python3-ptyprocess,
 python3-pygments,
 python3-rpy2,
 python3-scipy (>= 1.2),
 python3-setuptools,
 python3-setuptools-scm,
 python3-simplegeneric,
 python3-singledispatch,
 python3-snowballstemmer,
 python3-sphinx (>= 3.0),
 python3-stemmer,
 python3-sympy,
 python3-terminado,
 python3-tk,
 python3-tornado,
 python3-traitlets,
 python3-tz,
 python3-vcversioner,
 python3-wcwidth,
 python3-werkzeug,
 python3-zmq,
 python3-zope.interface,
 r-base-core,
 rubiks,
 sagemath-database-conway-polynomials (>= 0.5-7),
 sagemath-database-elliptic-curves,
 sagemath-database-graphs,
 sagemath-database-mutually-combinatorial-designs,
 sagemath-database-polytopes,
 singular (>= 1:4.1.1-p2),
 singular (<< 1:4.1.1-p3+ds-1),
 sqlite3,
 sympow (>= 1.023-9),
 tachyon,
 xcas,
 yasm,
 sagemath-common (= ${source:Version})
Recommends:
 maxima-sage-doc (>= 5.42.2),
 pari-doc (>= 2.11.0),
 python3-sagenb-export (>= 3.2),
 r-cran-lattice,
 singular-doc (>= 1:4.1.1-p2),
 singular-doc (<< 1:4.1.1-p3+ds-1),
 sagemath-doc (= ${source:Version}),
 sagemath-jupyter (= ${source:Version}),
 sagetex,
 texlive-latex-base
Suggests:
 dot2tex,
 gap-design,
 gap-factint,
 gap-grape,
 gap-guava,
 gap-laguna,
 gap-sonata,
 gap-toric

Package: sagemath-common
Architecture: all
Multi-Arch: foreign
Description: Open Source Mathematical Software - architecture-independent files
 SageMath is a free open-source mathematics software system licensed under the
 GPL. It builds on top of many existing open-source packages: NumPy, SciPy,
 matplotlib, Sympy, Maxima, GAP, FLINT, R and many more. Access their combined
 power through a common, Python-based language or directly via interfaces or
 wrappers.
 .
 Mission: Creating a viable free open source alternative to Magma, Maple,
 Mathematica and Matlab.
 .
 This package contains the architecture-independent files of SageMath.
Depends: ${misc:Depends}, ${python3:Depends}

Package: sagemath-jupyter
Architecture: all
Multi-Arch: foreign
Description: Open Source Mathematical Software - Jupyter kernel
 SageMath is a free open-source mathematics software system licensed under the
 GPL. It builds on top of many existing open-source packages: NumPy, SciPy,
 matplotlib, Sympy, Maxima, GAP, FLINT, R and many more. Access their combined
 power through a common, Python-based language or directly via interfaces or
 wrappers.
 .
 Mission: Creating a viable free open source alternative to Magma, Maple,
 Mathematica and Matlab.
 .
 This package contains the Jupyter kernel of SageMath.
Depends: ${misc:Depends},
 jupyter-client,
 jupyter-core,
 jupyter-nbextension-jupyter-js-widgets,
 python3-ipykernel,
 python3-ipywidgets (>= 6.0.0),
 python3-nbconvert,
 python3-nbformat,
 python3-notebook (>= 4.2.3-3),
 sagemath (>= ${source:Version}), sagemath (<< ${source:Version}.1~)

Package: sagemath-doc
Architecture: all
Multi-Arch: foreign
Description: Open Source Mathematical Software - documentation
 SageMath is a free open-source mathematics software system licensed under the
 GPL. It builds on top of many existing open-source packages: NumPy, SciPy,
 matplotlib, Sympy, Maxima, GAP, FLINT, R and many more. Access their combined
 power through a common, Python-based language or directly via interfaces or
 wrappers.
 .
 Mission: Creating a viable free open source alternative to Magma, Maple,
 Mathematica and Matlab.
 .
 This package contains the documentation.
Depends: ${misc:Depends}
Breaks: sagemath-doc-ca (<< 8.9~beta9-1~), sagemath-doc-de (<< 8.9~beta9-1~),
 sagemath-doc-en (<< 8.9~beta9-1~), sagemath-doc-es (<< 8.9~beta9-1~),
 sagemath-doc-fr (<< 8.9~beta9-1~), sagemath-doc-hu (<< 8.9~beta9-1~),
 sagemath-doc-it (<< 8.9~beta9-1~), sagemath-doc-ja (<< 8.9~beta9-1~),
 sagemath-doc-pt (<< 8.9~beta9-1~), sagemath-doc-ru (<< 8.9~beta9-1~),
 sagemath-doc-tr (<< 8.9~beta9-1~)
Replaces: sagemath-doc-ca (<< 8.9~beta9-1~), sagemath-doc-de (<< 8.9~beta9-1~),
 sagemath-doc-en (<< 8.9~beta9-1~), sagemath-doc-es (<< 8.9~beta9-1~),
 sagemath-doc-fr (<< 8.9~beta9-1~), sagemath-doc-hu (<< 8.9~beta9-1~),
 sagemath-doc-it (<< 8.9~beta9-1~), sagemath-doc-ja (<< 8.9~beta9-1~),
 sagemath-doc-pt (<< 8.9~beta9-1~), sagemath-doc-ru (<< 8.9~beta9-1~),
 sagemath-doc-tr (<< 8.9~beta9-1~)

Package: sagemath-doc-en
Depends: sagemath-doc, ${misc:Depends}
Architecture: all
Multi-Arch: foreign
Priority: optional
Section: oldlibs
Description: transitional package
 This is a transitional package. It can safely be removed.

=== debian/rules ===
#!/usr/bin/make -f

#
# CONTENTS:
#
# 1. DEFINITIONS
# 2. GENERATE FILES
#    Targets to auto-generate files
# 3. PACKAGE BUILD
#    Mostly standard targets that are used during package build
# 4. TEST SUITE
# 5. MAINTAINER TARGETS
#    Convenience targets to be used by maintainers
#    Some are explained at https://wiki.debian.org/DebianScience/Sage
#

###############################################################################
# 1. DEFINITIONS
###############################################################################

include /usr/share/dpkg/pkg-info.mk
include /usr/share/dpkg/architecture.mk

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
else
NUMJOBS = 1
endif

# Some buildds are a bit slow, see https://buildd.debian.org/status/logs.php?pkg=gcc-7 for a fuller list
ifneq (,$(filter $(DEB_BUILD_ARCH),armel armhf mips mipsel mips64el))
export SAGE_TIMEOUT_LONG = 7200
else
export SAGE_TIMEOUT_LONG = 3600
endif

export DOT_SAGE = $(CURDIR)/debian/test

%:
	dh $@ --with=python3

###############################################################################
# 2. GENERATE FILES
###############################################################################

binary build clean install: debian/control

debian/control: debian/control.in
	cat $^ > "$@"
	sed -i -e '/RUNTIME_DEPENDS/ {' -e 'r debian/control.runtime-depends' -e 'd' -e '}' "$@"
	sed -i -e '/RUNTIME_RECOMMENDS/ {' -e 'r debian/control.runtime-recommends' -e 'd' -e '}' "$@"
	sed -i -e '/JUPYTER_DEPENDS/ {' -e 'r debian/control.jupyter-depends' -e 'd' -e '}' "$@"

###############################################################################
# 3. PACKAGE BUILD
###############################################################################

run_build = \
	MAKE='make -j$(NUMJOBS)' \
	  $(MAKE) --directory=sage

override_dh_auto_configure:
	cd sage && ./bootstrap
	cd sage && ./configure --enable-build-as-root
	debian/depcheck.py

clean:

override_dh_auto_build-arch:
	$(run_build) build

override_dh_auto_build-indep:
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
	$(run_build) doc
	cd sage/local/share/doc/sagemath/html && \
	for statdir in */*/_static; do ln -s /usr/share/javascript/mathjax "$$statdir"; done && \
	for statdir in */_static; do ln -s /usr/share/javascript/mathjax "$$statdir"; done
endif

override_dh_auto_install:
	mkdir -p debian/tmp
	mv sage/local debian/tmp/usr
	mv debian/tmp/usr/lib/python3.* debian/tmp/usr/lib/python3
	mv debian/tmp/usr/lib/python3/site-packages debian/tmp/usr/lib/python3/dist-packages
	mkdir -p debian/tmp/usr/share/sagemath/bin
	cp sage/src/bin/sage-* debian/tmp/usr/share/sagemath/bin
	rm -f debian/tmp/usr/bin/sage-*
	rm -f debian/tmp/usr/share/sagemath/bin/sage-env*
	rm -f debian/tmp/usr/share/sagemath/bin/sage-*.bat
# We built .pyo to make the docbuild/tests go faster, but as per Debian policy
# we don't distribute them.
	find debian/tmp '(' -name '*.pyc' -o -name '*.pyo' ')' -delete
# Install (renamed) icons.
	mkdir -p debian/tmp/usr/share/icons/hicolor/64x64/apps
	mkdir -p debian/tmp/usr/share/icons/hicolor/scalable/apps
	cp -f sage/src/sage/ext_data/notebook-ipython/logo-64x64.png debian/tmp/usr/share/icons/hicolor/64x64/apps/sagemath.png
	cp -f sage/src/sage/ext_data/notebook-ipython/logo.svg debian/tmp/usr/share/icons/hicolor/scalable/apps/sagemath.svg
# Fix up jupyter kernel installation
	rm -f debian/tmp/usr/share/jupyter/nbextensions/jsmol
	rm -f debian/tmp/usr/share/jupyter/kernels/sagemath/logo*
	rm -f debian/tmp/usr/share/jupyter/kernels/sagemath/doc
	ln -s /usr/share/doc/sagemath/html/en debian/tmp/usr/share/jupyter/kernels/sagemath/doc
	ln -s /usr/share/icons/hicolor/64x64/apps/sagemath.png debian/tmp/usr/share/jupyter/kernels/sagemath/logo-64x64.png
	ln -s /usr/share/icons/hicolor/scalable/apps/sagemath.svg debian/tmp/usr/share/jupyter/kernels/sagemath/logo.svg
	sed -E 's|\[\".+bin/sage\",|\[\"/usr/bin/sage\",|' -i debian/tmp/usr/share/jupyter/kernels/sagemath/kernel.json

#override_dh_auto_clean:
#	dh_auto_clean -Dsage -- maintainer-clean
#	rm -f sage/config.status

override_dh_install-indep:
	dh_install --package sagemath-common -X.so
	dh_install --remaining-packages --list-missing
# Basic version of deduplicating the docs, for a much smaller install size.
# Upstream bug report is at https://trac.sagemath.org/ticket/22088
# Hard links do work in Debian packages, but only within packages.
	rdfind -outputname /dev/null -makehardlinks true debian/sagemath-doc; \

override_dh_python3-arch:
	dh_python3
	dh_numpy3 --package sagemath # stop lintian complaining at us

override_dh_shlibdeps:
	dh_shlibdeps -l debian/tmp/usr/lib

override_dh_compress:
# We probably don't need to install the pickle/doctree files but let's exempt
# them from compression anyway for now, so the build goes quicker.
	dh_compress -X.pdf -X.pickle -X.doctree

override_dh_clean:
	rm -rf $(DOT_SAGE)
	dh_clean

override_dh_strip_nondeterminism:
	dh_strip_nondeterminism -X.png # On png files it sometimes fails claiming it's not a png file.

###############################################################################
# 4. TEST SUITE
###############################################################################

MAX_TEST_FAILURES_RERUN = $(shell expr 2 \* $(MAX_TEST_FAILURES))

ifeq (,$(filter pkg.sagemath.nolongcheck,$(DEB_BUILD_PROFILES)))
SAGE_TEST_FLAGS_ARCH = --optional=sage,python3,memlimit --long
SAGE_TEST_FLAGS_INDEP = --optional=sage,python3,memlimit,dochtml --long
else
SAGE_TEST_FLAGS_ARCH = --optional=sage,python3,memlimit
SAGE_TEST_FLAGS_INDEP = --optional=sage,python3,memlimit,dochtml
endif

TESTS_MK = $(MAKE) -s --no-print-directory -f debian/tests.mk LOGFILE=$(LOGFILE)
failed-tests%:
	@$(TESTS_MK) "$@"

# We used to set this for i386 but it seems to be OK now.
# Perhaps we should set it for armhf, let's see the buildd test results...
ifneq (,$(filter $(DEB_BUILD_ARCH),))
IGNORE_FAILURES = | sed -e '0,/Timed out/{//d;}' -e '0,/Timed out/{//d;}' -e '0,/Timed out/{//d;}'
else
IGNORE_FAILURES =
endif
had-few-failures:
	if ! test -f $(LOGFILE); then echo "Error: log file $(LOGFILE) not found"; false; fi
	N_TEST_FAILURES="$$($(TESTS_MK) failed-tests-total-normal)"; \
	  if ! test $${N_TEST_FAILURES} -le $(MAX_TEST_FAILURES); then \
	    echo "Error: $${N_TEST_FAILURES} tests failed, up to $(MAX_TEST_FAILURES) failures are tolerated"; \
	    false; \
	  else \
	    echo "Success: $${N_TEST_FAILURES} tests failed, up to $(MAX_TEST_FAILURES) failures are tolerated"; \
	  fi
	if ! test -z "$$($(TESTS_MK) failed-tests-special $(IGNORE_FAILURES))"; then \
	  echo "Error: critical test failures (e.g. timeout, segfault, etc.)"; false; fi

had-not-too-many-failures:
	echo "Checking number of failed tests to determine whether to rerun tests in series..."
	if ! test -f $(LOGFILE); then echo "Error: log file $(LOGFILE) not found"; false; fi
	N_TEST_FAILURES="$$($(TESTS_MK) failed-tests-total-normal)"; \
	  if ! test $${N_TEST_FAILURES} -le $(MAX_TEST_FAILURES_RERUN); then \
	    echo "No: $${N_TEST_FAILURES} tests failed, up to $(MAX_TEST_FAILURES_RERUN) failures are tolerated for rerun"; \
	    false; \
	  else \
	    echo "Yes: $${N_TEST_FAILURES} tests failed, up to $(MAX_TEST_FAILURES_RERUN) failures are tolerated for rerun"; \
	  fi

run_tests = \
	cd sage && ./sage -t -p $(NUMJOBS) --logfile=logs/ptestlong-$(1).log $(2)
# If tests fail but not by too many more, then retry them once not in parallel
# i386 seems to have issues running parallel tests - TODO: investigate this in more detail
check_test_log = debian/rules -s LOGFILE=sage/logs/ptestlong-$(1).log MAX_TEST_FAILURES=$(3)
run_tests_with_retry = \
	$(run_tests); cd "$(CURDIR)" && \
	if $(check_test_log) had-few-failures; then :; else \
	  $(check_test_log) had-not-too-many-failures && \
	  mv sage/logs/ptestlong-$(1).log sage/logs/ptestlong-$(1).log.1 && \
	  { $(run_tests) -p 1 -f; cd "$(CURDIR)" && \

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/sage-$1\.tar\.gz/ \
  https://github.com/sagemath/sage/tags .*/([\d\.]+)\.tar\.gz
